#include "ofApp.h"
//--------------------------------------------------------------
void ofApp::setup(){
    ofBackground(0, 0, 0);
    ofSetVerticalSync(true);
    //Box2D initialization
    box2d.init();
	box2d.setGravity(0, 10);
	box2d.createBounds();
	box2d.setFPS(30.0);
}
//--------------------------------------------------------------
void ofApp::update(){
    box2d.update();
}
//--------------------------------------------------------------
void ofApp::draw(){
    for(int i=0; i<myCircles.size(); i++){
        //ofFill();
        //ofSetColor(0, 255, ofRandom(255));
        myCircles[i].draw();
    }
    ofSetColor(255);
    ofDrawBitmapString("Press arrow keys to change gravity direction, click to add circles, press backspace to delete", 20, ofGetHeight()-20);
}
//--------------------------------------------------------------
void ofApp::keyPressed(int key){
}
//--------------------------------------------------------------
void ofApp::keyReleased(int key){
    if(key==OF_KEY_UP){
        box2d.setGravity(0, -10);
    }
    if(key==OF_KEY_DOWN){
        box2d.setGravity(0, 10);
    }
    if(key==OF_KEY_LEFT){
        box2d.setGravity(-10, 0);
    }
    if(key==OF_KEY_RIGHT){
        box2d.setGravity(10, 0);
    }
    if(key==OF_KEY_BACKSPACE){
        myCircles.pop_back();
    }


}
//--------------------------------------------------------------
void ofApp::mouseMoved(int x, int y ){
}
//--------------------------------------------------------------
void ofApp::mouseDragged(int x, int y, int button){
}
//--------------------------------------------------------------
void ofApp::mousePressed(int x, int y, int button){
}
//--------------------------------------------------------------
void ofApp::mouseReleased(int x, int y, int button){
    ofxBox2dCircle myCircle;
    //parameters of setPhysics: density, bounce, friction
    float randomSize = ofRandom(1,5);
    myCircle.setPhysics(randomSize, 0.9, 1);
    myCircle.setup(box2d.getWorld(),x,y,randomSize*20);
    myCircles.push_back(myCircle);
}
//--------------------------------------------------------------
void ofApp::windowResized(int w, int h){
}

//--------------------------------------------------------------
void ofApp::gotMessage(ofMessage msg){

}

//--------------------------------------------------------------
void ofApp::dragEvent(ofDragInfo dragInfo){ 

}